; ----------------------------------------
;  blue-client.scm - Ben VandenBos
;  
;  *main file for the blue project client
; ---------------------------------------


(define *server-address* "localhost")
(define *server-port* "32000")   ; Default server port
(define *nickname* "Player")
(define *wire-frame?* #f)        ; Use a wire-frame tank?
(define *debug* #f)

(require (lib "compile.ss"))
(load "client-load-gifs.scm")          ; Load the bitmaps...

(display "Compiling source...")
(compile-file "blue-util.scm")
(display ".")
(compile-file "client-gui.scm")                ; GUI Definition and Console functions
(display ".")
(compile-file "client-draw-objects.scm")       ; Tank Drawing Functions (wire-frame)
(display ".")
(compile-file "client-exact-position.scm")     ; Functions for determining the exact position of objects based on time
(display "..")
(compile-file "client-called-by-server.scm")   ; Functions that are called from the server (run on the client)
(display ".")
(compile-file "client-controls.scm")           ; Functions to handle the controls
(display "..")
(compile-file "client-connection.scm")  ; Connection and game-state functions and vars
(display ".")
(compile-file "client-collisions.scm")         ; Functions for detecting collisions
(display "Done\n")

(display "Loading...")

(load "compiled/blue-util.zo")
(display ".")
(load "compiled/client-gui.zo")
(display "..")
(load "compiled/client-draw-objects.zo")
(display "...")
(load "compiled/client-exact-position.zo")
(display "...")
(load "compiled/client-called-by-server.zo")
(display "...")
(load "compiled/client-controls.zo")
(display "...")
(load "compiled/client-connection.zo")
(display "...")
(load "compiled/client-collisions.zo")
(display "Done\n")
