;;; initial 'blue' server code
;;; Justin R. Hall (c) 2003

;;; global server variables
(define *debug* #t)
(define *init-vector-size* 20)
(define *connection-index* 0)
(define *game-state* (make-vector *init-vector-size* '()))
(define *ports-assoc* (make-hash-table))
(define *obj-assoc* (make-hash-table))
(define *output-ports* (make-vector *init-vector-size* '()))
(define *threads* (make-vector *init-vector-size* '()))
(define *server-semaphore* (make-semaphore 1))
(define *server-port* 32000)

;;; for compiling
(require (lib "compile.ss"))

(display "Compiling server code...")
(compile-file "blue-util.scm")
(display "..")
(compile-file "server-util.scm")
(display "..")
(compile-file "server-communications.scm")
(display "..")
(compile-file "server-objects.scm")
(display "..")
(compile-file "server-collisions.scm")
(display "..")
(compile-file "server-handshake.scm")
(display "..")
(display "done.")
(newline)

(display "Loading server..........")
(load "compiled/blue-util.zo")
(display "..")
(load "compiled/server-util.zo")
(display "..")
(load "compiled/server-communications.zo")
(display "..")
(load "compiled/server-objects.zo")
(display "..")
(load "compiled/server-collisions.zo")
(display "..")
(load "compiled/server-handshake.zo")
(display "..")
(display "done.")
(newline)

(display "Running 'blue' server now...")
(newline)
(server *server-port*)
