; --------------------------------------------
;  controls.scm - Ben VandenBos
;  
;  *function for handling input from the user
;  *messy, could stand to be re-written
; --------------------------------------------

(define handle-controls
  (lambda (key-code key-release-code)
    (if *playing*
        (let ((current-movement (object-movement (vector-ref *game-state* *you-are-index*)))
              (current-rotate (object-rotate (vector-ref *game-state* *you-are-index*)))
              (update? #f)
              (obj (vector-ref *game-state* *you-are-index*)))
          (let ((pos (exact-position obj)))
            ; Handle the press event sets
            (cond
              ((eqv? key-code #\space)
               (fire))
              ((and (eqv? key-code 'right) (eqv? current-rotate 'stop))
               (set! update? #t)
               (semaphore-wait *game-state-semaphore*)
               (if *playing*
                   (begin
                     (set-object-time-stamp! (vector-ref *game-state* *you-are-index*) (current-milliseconds))
                     (set-object-rotate! (vector-ref *game-state* *you-are-index*) 'right)))
               (semaphore-post *game-state-semaphore*))
              ((and (eqv? key-code 'left) (eqv? current-rotate 'stop))
               (set! update? #t)
               (semaphore-wait *game-state-semaphore*)
               (if *playing*
                   (begin           
                     (set-object-time-stamp! (vector-ref *game-state* *you-are-index*) (current-milliseconds))
                     (set-object-rotate! (vector-ref *game-state* *you-are-index*) 'left)))
               (semaphore-post *game-state-semaphore*))
              ((and (eqv? key-code 'up) (eqv? current-movement 'stop))
               (set! update? #t)
               (semaphore-wait *game-state-semaphore*)
               (if *playing*
                   (begin           
                     (set-object-time-stamp! (vector-ref *game-state* *you-are-index*) (current-milliseconds))
                     (set-object-movement! (vector-ref *game-state* *you-are-index*) 'up)))
               (semaphore-post *game-state-semaphore*))
              ((and (eqv? key-code 'down) (eqv? current-movement 'stop))
               (set! update? #t)
               (semaphore-wait *game-state-semaphore*)
               (if *playing*
                   (begin           
                     (set-object-time-stamp! (vector-ref *game-state* *you-are-index*) (current-milliseconds))
                     (set-object-movement! (vector-ref *game-state* *you-are-index*) 'down)))
               (semaphore-post *game-state-semaphore*))
              )
            (if (or update? (eqv? key-code 'release))
                (begin
                  (semaphore-wait *game-state-semaphore*)
                  (if *playing*
                      (begin              
                        (set-object-x! (vector-ref *game-state* *you-are-index*) (car pos))
                        (set-object-y! (vector-ref *game-state* *you-are-index*) (cadr pos))
                        (set-object-theta! (vector-ref *game-state* *you-are-index*) (caddr pos))
                        (set-object-time-stamp! (vector-ref *game-state* *you-are-index*) (current-milliseconds))
                        (cond
                          ((eqv? key-release-code 'left)
                           (set-object-rotate! (vector-ref *game-state* *you-are-index*) 'stop))
                          ((eqv? key-release-code 'right)
                           (set-object-rotate! (vector-ref *game-state* *you-are-index*) 'stop))
                          ((eqv? key-release-code 'up)
                           (set-object-movement! (vector-ref *game-state* *you-are-index*) 'stop))
                          ((eqv? key-release-code 'down)
                           (set-object-movement! (vector-ref *game-state* *you-are-index*) 'stop))
                          )
                        )
                      )
                  (semaphore-post *game-state-semaphore*)
                  ; Send the new state to the server
                  (update-server *you-are-index*)
                  )
                )
            )
          )
        )
    )
  )